Title: WP_REST_Templates_Controller::register_routes
Published: July 20, 2021
Last modified: May 20, 2026

---

# WP_REST_Templates_Controller::register_routes()

## In this article

 * [Source](https://developer.wordpress.org/reference/classes/wp_rest_templates_controller/register_routes/?output_format=md#source)
 * [Related](https://developer.wordpress.org/reference/classes/wp_rest_templates_controller/register_routes/?output_format=md#related)
 * [Changelog](https://developer.wordpress.org/reference/classes/wp_rest_templates_controller/register_routes/?output_format=md#changelog)

[ Back to top](https://developer.wordpress.org/reference/classes/wp_rest_templates_controller/register_routes/?output_format=md#wp--skip-link--target)

Registers the controllers routes.

## 󠀁[Source](https://developer.wordpress.org/reference/classes/wp_rest_templates_controller/register_routes/?output_format=md#source)󠁿

    ```php
    public function register_routes() {
    	// Lists all templates.
    	register_rest_route(
    		$this->namespace,
    		'/' . $this->rest_base,
    		array(
    			array(
    				'methods'             => WP_REST_Server::READABLE,
    				'callback'            => array( $this, 'get_items' ),
    				'permission_callback' => array( $this, 'get_items_permissions_check' ),
    				'args'                => $this->get_collection_params(),
    			),
    			array(
    				'methods'             => WP_REST_Server::CREATABLE,
    				'callback'            => array( $this, 'create_item' ),
    				'permission_callback' => array( $this, 'create_item_permissions_check' ),
    				'args'                => $this->get_endpoint_args_for_item_schema( WP_REST_Server::CREATABLE ),
    			),
    			'schema' => array( $this, 'get_public_item_schema' ),
    		)
    	);

    	// Get fallback template content.
    	register_rest_route(
    		$this->namespace,
    		'/' . $this->rest_base . '/lookup',
    		array(
    			array(
    				'methods'             => WP_REST_Server::READABLE,
    				'callback'            => array( $this, 'get_template_fallback' ),
    				'permission_callback' => array( $this, 'get_item_permissions_check' ),
    				'args'                => array(
    					'slug'            => array(
    						'description' => __( 'The slug of the template to get the fallback for' ),
    						'type'        => 'string',
    						'required'    => true,
    					),
    					'is_custom'       => array(
    						'description' => __( 'Indicates if a template is custom or part of the template hierarchy' ),
    						'type'        => 'boolean',
    					),
    					'template_prefix' => array(
    						'description' => __( 'The template prefix for the created template. This is used to extract the main template type, e.g. in `taxonomy-books` extracts the `taxonomy`' ),
    						'type'        => 'string',
    					),
    				),
    			),
    		)
    	);

    	// Lists/updates a single template based on the given id.
    	register_rest_route(
    		$this->namespace,
    		// The route.
    		sprintf(
    			'/%s/(?P<id>%s%s)',
    			$this->rest_base,
    			/*
    			 * Matches theme's directory: `/themes/<subdirectory>/<theme>/` or `/themes/<theme>/`.
    			 * Excludes invalid directory name characters: `/:<>*?"|`.
    			 */
    			'([^\/:<>\*\?"\|]+(?:\/[^\/:<>\*\?"\|]+)?)',
    			// Matches the template name.
    			'[\/\w%-]+'
    		),
    		array(
    			'args'   => array(
    				'id' => array(
    					'description'       => __( 'The id of a template' ),
    					'type'              => 'string',
    					'sanitize_callback' => array( $this, '_sanitize_template_id' ),
    				),
    			),
    			array(
    				'methods'             => WP_REST_Server::READABLE,
    				'callback'            => array( $this, 'get_item' ),
    				'permission_callback' => array( $this, 'get_item_permissions_check' ),
    				'args'                => array(
    					'context' => $this->get_context_param( array( 'default' => 'view' ) ),
    				),
    			),
    			array(
    				'methods'             => WP_REST_Server::EDITABLE,
    				'callback'            => array( $this, 'update_item' ),
    				'permission_callback' => array( $this, 'update_item_permissions_check' ),
    				'args'                => $this->get_endpoint_args_for_item_schema( WP_REST_Server::EDITABLE ),
    			),
    			array(
    				'methods'             => WP_REST_Server::DELETABLE,
    				'callback'            => array( $this, 'delete_item' ),
    				'permission_callback' => array( $this, 'delete_item_permissions_check' ),
    				'args'                => array(
    					'force' => array(
    						'type'        => 'boolean',
    						'default'     => false,
    						'description' => __( 'Whether to bypass Trash and force deletion.' ),
    					),
    				),
    			),
    			'schema' => array( $this, 'get_public_item_schema' ),
    		)
    	);
    }
    ```

[View all references](https://developer.wordpress.org/reference/files/wp-includes/rest-api/endpoints/class-wp-rest-templates-controller.php/)
[View on Trac](https://core.trac.wordpress.org/browser/tags/7.0/src/wp-includes/rest-api/endpoints/class-wp-rest-templates-controller.php#L47)
[View on GitHub](https://github.com/WordPress/wordpress-develop/blob/7.0/src/wp-includes/rest-api/endpoints/class-wp-rest-templates-controller.php#L47-L149)

## 󠀁[Related](https://developer.wordpress.org/reference/classes/wp_rest_templates_controller/register_routes/?output_format=md#related)󠁿

| Uses | Description | 
| [WP_REST_Templates_Controller::get_collection_params()](https://developer.wordpress.org/reference/classes/wp_rest_templates_controller/get_collection_params/)`wp-includes/rest-api/endpoints/class-wp-rest-templates-controller.php` |

Retrieves the query params for the posts collection.

  | 
| [register_rest_route()](https://developer.wordpress.org/reference/functions/register_rest_route/)`wp-includes/rest-api.php` |

Registers a REST API route.

  | 
| [__()](https://developer.wordpress.org/reference/functions/__/)`wp-includes/l10n.php` |

Retrieves the translation of $text.

  |

[Show 1 more](https://developer.wordpress.org/reference/classes/wp_rest_templates_controller/register_routes/?output_format=md#)
[Show less](https://developer.wordpress.org/reference/classes/wp_rest_templates_controller/register_routes/?output_format=md#)

## 󠀁[Changelog](https://developer.wordpress.org/reference/classes/wp_rest_templates_controller/register_routes/?output_format=md#changelog)󠁿

| Version | Description | 
| [6.1.0](https://developer.wordpress.org/reference/since/6.1.0/) | Endpoint for fallback template content. | 
| [5.8.0](https://developer.wordpress.org/reference/since/5.8.0/) | Introduced. |

## User Contributed Notes

You must [log in](https://login.wordpress.org/?redirect_to=https%3A%2F%2Fdeveloper.wordpress.org%2Freference%2Fclasses%2Fwp_rest_templates_controller%2Fregister_routes%2F)
before being able to contribute a note or feedback.